#  Pace: 0 ... 9
#  0 = Fast ...  9 = Slow

from random import *
from time import *
from ti_system import *
seed(int(clock()))

black=(0,0,0)
white=(255,255,255)
gray=(230,230,230)
blue=(72,118,255)

board=[[5,27,16,5], [21,21,38,21]]

def draw_board():
  set_color(gray)
  fill_poly(board[0],board[1])
  set_color(black)
  for i in range(6):
    for j in range(i):
      x=18-2*i+4*j
      y=37-3*i
      fill_circle(x,y,0.15)

def draw_bins():
  set_color(white)
  fill_rect(2,0,30,21)
  set_color(blue)
  for i in range(6):
    fill_rect(4+4*i,4.9,4.1,bin[i]*factor)
  set_color(black)
  for i in range(7):
    draw_line(4+4*i,20,4+4*i,5)
  draw_line(4,5,28,5)
  for i in range(1,7):
    draw_text(4*i+1.5,2,str(i))

def draw_table():
  set_color(white)
  fill_rect(38,0,32,40)
  set_color(gray)
  fill_rect(38,5.6,18,25)
  set_color(white)
  for i in range(6):
    draw_line(38,9+3.5*i,56,9+3.5*i)
  draw_line(42,6,42,36)
  draw_line(49,6,49,36)
  set_color(black)
  draw_text(39,27,"n")
  draw_text(45,27,"#")
  draw_text(51.5,27,"%")
  for i in range(6):
    draw_text(39,23.3-3.5*i,str(i+1))
    draw_text(43.5,23.3-3.5*i,("  "+str(bin[i]))[-3:])
    draw_text(50.5,23.3-3.5*i,("  "+str(prob[i]))[-3:])
  draw_text(41,2,"Total: "+str(total))

def draw_ball(x,y):
  set_color(blue)
  fill_circle(x,y,1)
  set_color(black)

total=0
bin=[0]*6
prob=[0]*6
set_window(0,60,0,40)
use_buffer()
s=0.15
factor=0.5
draw_bins()
draw_table()

key=""
while key != "esc":
  x=16; y=35
  index=0
  draw_board()
  draw_ball(x,y)
  paint_buffer()
  for r in range(5):
    key=get_key()
    if key=="esc":
      break
    if key in {"0","1","2","3","4","5","6","7","8","9"}:
      s=int(key)/20
    draw_board()
    r=randint(0,1)
    index+=r
    x=x+4*r-2
    y=y-3
    sleep(s)
    draw_ball(x,y)
    paint_buffer()
  if key=="esc":
    break
  for y in range(17,6,-2):
    draw_bins()
    draw_ball(x,y)
    paint_buffer()
  total+=1
  bin[index]+=1
  prob[index]=round(100*bin[index]/total)
  draw_bins()
  draw_table()
  paint_buffer()
  if max(bin)*factor>13:
    factor=factor*0.95
