from ti_system import *
from math import *
from ti_draw import *

f=0.5*sqrt(3)

def rotation(x,y,p,q,angle):
  a=radians(angle)
  x1=(x-p)*cos(a)-(y-q)*sin(a)+p
  y1=(x-p)*sin(a)+(y-q)*cos(a)+q
  return (x1,y1)

def tile_1(x,y,side,lines,fillcolor,rot):
  px=[0,0,9*f,9*f,0]
  py=[0,-9,-4.5,4.5,0]
  for i in range(5):
    px[i]=x+side*px[i]
    py[i]=y+side*py[i]
    px[i],py[i]=rotation(px[i],py[i],x,y,rot)
  set_color(fillcolor)
  fill_poly(px,py)
  if lines:
    set_color(black)
    draw_poly(px,py)

def tile_2(x,y,side,lines,fillcolor,rot):
  px=[0,0,2*f,2*f,7*f,7*f,0]
  py=[0,-7,-6,-1,1.5,3.5,0]
  for i in range(7):
    px[i]=x+side*px[i]
    py[i]=y+side*py[i]
    px[i],py[i]=rotation(px[i],py[i],x,y,rot)
  set_color(fillcolor)
  fill_poly(px,py)
  if lines:
    set_color(black)
    draw_poly(px,py)

def tile_3(x,y,side,lines,fillcolor,rot):
  px=[0,2*f,2*f,0,0]
  py=[-0.5,-1.5,1.5,0.5,-0.5]
  for i in range(5):
    px[i]=x+side*px[i]
    py[i]=y+side*py[i]
    px[i],py[i]=rotation(px[i],py[i],x,y,rot)
  set_color(fillcolor)
  fill_poly(px,py)
  if lines:
    set_color(black)
    draw_poly(px,py)

def tile_4(x,y,side,lines,fillcolor,rot):
  px=[-f,0,0,-f]
  py=[0,-0.5,0.5,0]
  for i in range(4):
    px[i]=x+side*px[i]
    py[i]=y+side*py[i]
    px[i],py[i]=rotation(px[i],py[i],x,y,rot)
  set_color(fillcolor)
  fill_poly(px,py)
  if lines:
    set_color(black)
    draw_poly(px,py)

def draw_screen(lines,fillcolor):
  for i in range(-num//2-1,num/2+1):
    for j in range(-num//4-2,num/4+1):
      x=i*9*f*side
      y=j*27*side+13.5*side*(i%2)
      for k in range(3):
        tile_1(x,y,side,lines,fillcolor[k],120*k)
  for i in range(-num//2-1,num/2+1):
    for j in range(-num//4-2,num/4+1):
      x=i*9*f*side
      y=j*27*side+13.5*side*(i%2)
      for t in range(6):
        amp=5*f*side
        x1=x+amp*cos((t+2)*pi/3)
        y1=y+amp*sin((t+2)*pi/3)
        tile_3(x1,y1,side,lines,fillcolor[t//2],(t+2)*60)
        tile_4(x1,y1,side,lines,fillcolor[3],(t+2)*60)
  for i in range(-num//2-1,num/2+1):
    for j in range(-num//4-2,num/4+1):
      x=i*9*f*side
      y=(j*27+9)*side+13.5*side*(i%2)
      for k in range(3):
        tile_2(x,y,side,lines,fillcolor[k],120*k)
  paint_buffer()

black=(0,0,0)
white=(255,255,255)
light=(255,218,179)
middle=(198,110,46)
dark=(105,29,15)
red=(255,0,0)
yellow=(255,255,0)
blue=(0,0,255)

use_buffer()
set_window(-159,159,-106,106)

color=[light,middle,dark,black]
bw=[white,white,white,white]
lines=False
fillcolor=color
lines_only=False
side=6

key=""
while key!="esc":
  num=int(318/(6*side))
  draw_screen(lines,fillcolor)
  key=""
  while key not in ("esc","up","down","l","k","r"):
    key=get_key(1)
  if key=="down":
    side=max(2,side-1)
  if key=="up":
    side=min(16,side+1)
  if key=="l":
    lines_only=True
    fillcolor=bw
    lines=True
  if key=="k":
    fillcolor=color
    lines_only=False
    lines=False
  if key=="r":
    if not lines_only:
      lines=not lines
